%IDM_FILE    = %WM_USER + 7200
%IDM_NEW     = %WM_USER + 7201
%IDM_OPEN    = %WM_USER + 7202
%IDM_SAVE    = %WM_USER + 7203
%IDM_SAVEAS  = %WM_USER + 7204
%IDM_EDIT    = %WM_USER + 7220
%IDM_UNDO    = %WM_USER + 7221
%IDM_CUT     = %WM_USER + 7223
%IDM_COPY    = %WM_USER + 7224
%IDM_PASTE   = %WM_USER + 7225
%IDM_SELALL  = %WM_USER + 7226



  '
' Add a menu to given window/dialog
'--------------------------------------------------------------------
Sub addMenu (ByVal hDlg As Dword)
  Local hMnu As Dword, hmnuFile As Dword, hmnuEdit As Dword

  Menu New Bar To hMnu
  Menu New PopUp To hmnuFile
'--------------------------------------------------------------------

     Menu Add PopUp, hMnu, GetMenuTxtAndBmp(%IDM_FILE, 0), hmnuFile, %MF_ENABLED
     Menu Add String, hMnuFile, GetMenuTxtAndBmp(%ID_NEW, 0),    %ID_NEW,    %MF_ENABLED
     Menu Add String, hMnuFile, GetMenuTxtAndBmp(%ID_OPEN, 0),   %ID_OPEN,   %MF_ENABLED
     Menu Add String, hMnuFile, "-", 0, 0
     Menu Add String, hMnuFile, GetMenuTxtAndBmp(%ID_SAVE, 0),   %ID_SAVE,   %MF_ENABLED
     Menu Add String, hMnuFile, GetMenuTxtAndBmp(%ID_SAVEAS, 0), %ID_SAVEAS, %MF_ENABLED
     Menu Add String, hMnuFile, "-", 0, 0
     Menu Add String, hMnuFile, GetMenuTxtAndBmp(%ID_PRINT, 0),  %ID_PRINT, %MF_ENABLED
     Menu Add String, hMnuFile, "-", 0, 0
     Menu Add String, hMnuFile, GetMenuTxtAndBmp(%IDCANCEL, 0),   %IDCANCEL,   %MF_ENABLED

'--------------------------------------------------------------------

  Menu New PopUp To hmnuEdit
     Menu Add PopUp, hMnu, GetMenuTxtAndBmp(%IDM_EDIT, 0), hmnuEdit, %MF_ENABLED
     Menu Add String, hmnuEdit, GetMenuTxtAndBmp(%ID_UNDO, 0),   %ID_UNDO,   %MF_ENABLED
     Menu Add String, hmnuEdit, GetMenuTxtAndBmp(%ID_REDO, 0),  %ID_REDO,   %MF_ENABLED

     Menu Add String, hMnuEdit, "-", 0, 0
     Menu Add String, hmnuEdit, GetMenuTxtAndBmp(%ID_CUT, 0),    %ID_CUT,    %MF_ENABLED
     Menu Add String, hmnuEdit, GetMenuTxtAndBmp(%ID_COPY, 0),   %ID_COPY,   %MF_ENABLED
     Menu Add String, hmnuEdit, GetMenuTxtAndBmp(%ID_PASTE, 0),  %ID_PASTE,  %MF_ENABLED
     Menu Add String, hmnuEdit, GetMenuTxtAndBmp(%ID_DELETE, 0),  %ID_DELETE,  %MF_ENABLED

     Menu Add String, hMnuEdit, "-", 0, 0
     Menu Add String, hmnuEdit, GetMenuTxtAndBmp(%ID_SELALL, 0), %ID_SELALL, %MF_ENABLED
     Menu Add String, hMnuEdit, "-", 0, 0



     Local hPopUp2 As Dword

    Menu New PopUp To hPopup2
     Menu Add PopUp, hMnuEdit, GetMenuTxtAndBmp(%ID_LINES, 0), hPopup2, %MF_ENABLED
     Menu Add String, hPopup2, "", %ID_REM, %MF_ENABLED
     Menu Add String, hPopup2, "", %ID_NOREM, %MF_ENABLED
     Menu Add String, hMnuEdit, "-", 0, 0
     Menu Add String, hMnuEdit, GetMenuTxtAndBmp(%ID_FIND_DIALOG, 0), %ID_FIND_DIALOG, %MF_ENABLED
     Menu Add String, hMnuEdit,  GetMenuTxtAndBmp(%ID_FIND_NEXT, 0), %ID_FIND_NEXT, %MF_ENABLED
     Menu Add String, hMnuEdit, GetMenuTxtAndBmp(%ID_REPLACE_DIALOG, 0), %ID_REPLACE_DIALOG, %MF_ENABLED
     Menu Add String, hMnuEdit, "-", 0, 0

     Menu Add String, hMnuEdit, GetMenuTxtAndBmp(%ID_GOTO_DIALOG, 0), %ID_GOTO_DIALOG, %MF_ENABLED
     Menu Add String, hMnuEdit, GetMenuTxtAndBmp(%ID_CODE_FINDER_DIALOG, 0), %ID_CODE_FINDER_DIALOG, %MF_ENABLED

     Local hPopUp3 As Dword

     Menu New PopUp To hPopup3
     Menu Add PopUp, hMnuEdit, GetMenuTxtAndBmp(%ID_BOOKMARKS, 0), hPopup3, %MF_ENABLED
     Menu Add String, hPopup3,  GetMenuTxtAndBmp(%ID_BMSET, 0), %ID_BMSET, %MF_ENABLED
     Menu Add String, hPopup3, GetMenuTxtAndBmp(%ID_BMSUBS, 0), %ID_BMSUBS, %MF_ENABLED
     Menu Add String, hPopup3, "-", 0, 0

     Menu Add String, hPopup3, GetMenuTxtAndBmp(%ID_BMNEXT, 0), %ID_BMNEXT, %MF_ENABLED
     Menu Add String, hPopup3, GetMenuTxtAndBmp(%ID_BMPREV, 0), %ID_BMPREV, %MF_ENABLED
     Menu Add String, hPopup3, "-",0, 0
     Menu Add String, hPopup3, GetMenuTxtAndBmp(%ID_BMCLEAR, 0), %ID_BMCLEAR, %MF_ENABLED

     Local hmnuRun As Dword
     Menu New PopUp To hmnuRun
     Menu Add PopUp,  hMnu,   GetMenuTxtAndBmp(%ID_RUN, 0), hmnuRun, %MF_ENABLED
     Menu Add String, hmnuRun, GetMenuTxtAndBmp(%ID_COMPILE, 0), %ID_COMPILE, %MF_ENABLED
     Menu Add String, hmnuRun, GetMenuTxtAndBmp(%ID_COMPILE_EXEC, 0), %ID_COMPILE_EXEC, %MF_ENABLED

     Local hmnuTools As Dword
     Menu New PopUp To hmnuTools
     Menu Add PopUp,  hMnu,   GetMenuTxtAndBmp(%ID_TOOLS, 0), hmnuTools, %MF_ENABLED
     Menu Add String, hmnuTools, GetMenuTxtAndBmp(%ID_OPTIONS , 0), %ID_OPTIONS , %MF_ENABLED


    Local hmnuHelp As Dword
    Menu New PopUp To hmnuHelp
    Menu Add PopUp,  hMnu,     GetMenuTxtAndBmp(%ID_HELP, 0), hmnuHelp, %MF_ENABLED
    Menu Add String, hmnuHelp, GetMenuTxtAndBmp(%ID_HELP_SDK, 0), %ID_HELP_SDK, %MF_ENABLED
    Menu Add String, hmnuHelp, GetMenuTxtAndBmp(%ID_WEB, 0), %ID_WEB, %MF_ENABLED
    Menu Add String, hmnuHelp, "-", 0, 0
    Menu Add String, hmnuHelp, GetMenuTxtAndBmp(%ID_ABOUT_DLG, 0), %ID_ABOUT_DLG, %MF_ENABLED



  Menu Attach hMnu, hDlg

  'Make all menu items ownerdrawn
  'FILE
  ModifyMenu hmnuFile, %ID_NEW,    %MF_OWNERDRAW, %ID_NEW,    ByVal %NULL
  ModifyMenu hmnuFile, %ID_OPEN,   %MF_OWNERDRAW, %ID_OPEN,   ByVal %NULL
  ModifyMenu hmnuFile, %ID_SAVE,   %MF_OWNERDRAW, %ID_SAVE,   ByVal %NULL
  ModifyMenu hmnuFile, %ID_SAVEAS, %MF_OWNERDRAW, %ID_SAVEAS, ByVal %NULL

  ModifyMenu hmnuFile, %ID_PRINT,  %MF_OWNERDRAW, %ID_PRINT, ByVal %NULL
  ModifyMenu hmnuFile, %IDCANCEL,   %MF_OWNERDRAW, %IDCANCEL,   ByVal %NULL

  'EDIT
  ModifyMenu hmnuEdit, %ID_UNDO,   %MF_OWNERDRAW, %ID_UNDO,   ByVal %NULL
  ModifyMenu hmnuEdit, %ID_REDO,   %MF_OWNERDRAW, %ID_REDO,   ByVal %NULL

  ModifyMenu hmnuEdit, %ID_CUT,    %MF_OWNERDRAW, %ID_CUT,    ByVal %NULL
  ModifyMenu hmnuEdit, %ID_COPY,   %MF_OWNERDRAW, %ID_COPY,   ByVal %NULL
  ModifyMenu hmnuEdit, %ID_PASTE,  %MF_OWNERDRAW, %ID_PASTE,  ByVal %NULL
  ModifyMenu hmnuEdit, %ID_DELETE, %MF_OWNERDRAW, %ID_DELETE,  ByVal %NULL
  ModifyMenu hmnuEdit, %ID_SELALL, %MF_OWNERDRAW, %ID_SELALL, ByVal %NULL
  ModifyMenu hmnuEdit, %ID_LINES,  %MF_OWNERDRAW, %ID_LINES, ByVal %NULL
  ModifyMenu hmnuEdit, %ID_REM,    %MF_OWNERDRAW, %ID_REM, ByVal %NULL
  ModifyMenu hmnuEdit, %ID_NOREM,    %MF_OWNERDRAW, %ID_NOREM, ByVal %NULL
  ModifyMenu hmnuEdit, %ID_FIND_DIALOG,    %MF_OWNERDRAW, %ID_FIND_DIALOG, ByVal %NULL

  ModifyMenu hmnuEdit, %ID_FIND_NEXT,    %MF_OWNERDRAW, %ID_FIND_NEXT, ByVal %NULL

  ModifyMenu hmnuEdit, %ID_REPLACE_DIALOG,    %MF_OWNERDRAW, %ID_REPLACE_DIALOG, ByVal %NULL
  ModifyMenu hmnuEdit, %ID_GOTO_DIALOG,    %MF_OWNERDRAW, %ID_GOTO_DIALOG, ByVal %NULL
  ModifyMenu hmnuEdit, %ID_CODE_FINDER_DIALOG,    %MF_OWNERDRAW, %ID_CODE_FINDER_DIALOG, ByVal %NULL
  ModifyMenu hmnuEdit, %ID_BOOKMARKS,    %MF_OWNERDRAW, %ID_BOOKMARKS, ByVal %NULL
  ModifyMenu hmnuEdit, %ID_BMSET,    %MF_OWNERDRAW, %ID_BMSET, ByVal %NULL
  ModifyMenu hmnuEdit, %ID_BMSUBS,    %MF_OWNERDRAW, %ID_BMSUBS, ByVal %NULL

  ModifyMenu hmnuEdit, %ID_BMNEXT,    %MF_OWNERDRAW, %ID_BMNEXT, ByVal %NULL
  ModifyMenu hmnuEdit, %ID_BMPREV,    %MF_OWNERDRAW, %ID_BMPREV, ByVal %NULL
  ModifyMenu hmnuEdit, %ID_BMCLEAR,    %MF_OWNERDRAW, %ID_BMCLEAR, ByVal %NULL
  ModifyMenu hmnuRun, %ID_RUN,    %MF_OWNERDRAW, %ID_RUN, ByVal %NULL
  ModifyMenu hmnuRun, %ID_COMPILE,    %MF_OWNERDRAW, %ID_COMPILE, ByVal %NULL
  ModifyMenu hmnuRun, %ID_COMPILE_EXEC,    %MF_OWNERDRAW, %ID_COMPILE_EXEC, ByVal %NULL

  ModifyMenu hmnuRun, %ID_TOOLS,    %MF_OWNERDRAW, %ID_TOOLS, ByVal %NULL
  ModifyMenu hmnuTools, %ID_OPTIONS ,    %MF_OWNERDRAW, %ID_OPTIONS , ByVal %NULL

  ModifyMenu hmnuHelp, %ID_HELP,        %MF_OWNERDRAW, %ID_HELP, ByVal %NULL
  ModifyMenu hmnuHelp, %ID_HELP_SDK,    %MF_OWNERDRAW, %ID_HELP_SDK, ByVal %NULL


  ModifyMenu hmnuHelp, %ID_WEB,    %MF_OWNERDRAW, %ID_WEB, ByVal %NULL
  ModifyMenu hmnuHelp, %ID_ABOUT_DLG,    %MF_OWNERDRAW, %ID_ABOUT_DLG, ByVal %NULL

End Sub

'
' Return menu item string and one-based bitmap number (0 = no bitmap)
'--------------------------------------------------------------------
Function GetMenuTxtAndBmp (ByVal ItemId As Long, BmpNum As Long) As String
  Select Case ItemId
     Case %IDM_FILE    : BmpNum = 0 : Function = "&File"

     Case %ID_NEW      : BmpNum = 2 : Function = "&New"      & $Tab & "Ctrl + N"
     Case %ID_OPEN     : BmpNum = 20 : Function = "&Open...     " & $Tab & "Ctrl + O"
     Case %ID_SAVE     : BmpNum = 1 : Function = "&Save       "     & $Tab & "Ctrl + S"
     Case %ID_SAVEAS   : BmpNum = 0 : Function = "&Save as...       "
     Case %ID_PRINT    : BmpNum = 23 : Function = "&Print"   & $Tab & "Ctrl + P"
     Case %IDCANCEL    : BmpNum = 0 : Function = "E&xit"     & $Tab & "Alt + F4"

     Case %IDM_EDIT    : BmpNum = 0 : Function = "&Edit"
     Case %ID_UNDO     : BmpNum = 5 : Function = "&Undo  "    & $Tab & "Ctrl + Z"
     Case %ID_REDO     : BmpNum = 39 : Function = "&Redo  "    & $Tab & "Ctrl + Y"

     Case %ID_CUT     : BmpNum = 6 : Function = "Cu&t  "     & $Tab & "Ctrl + X"
     Case %ID_COPY    : BmpNum = 7 : Function = "&Copy  "    & $Tab & "Ctrl + C"
     Case %ID_PASTE   : BmpNum = 8 : Function =  "Paste "   & $Tab &  "Ctrl + V"
     Case %ID_DELETE   : BmpNum = 3 : Function = "Delete"  &  $Tab

     Case %ID_SELALL  : BmpNum = 0 : Function = "Select &All " & $Tab & "Ctrl + A"
     Case %ID_LINES  : BmpNum = 35 : Function = "   &Lines"
'     Case %ID_REM      : BmpNum = 59 : Function = "Comment block               " + $Tab +  "Ctrl + Q"
'     Case %ID_NOREM    : BmpNum = 58 : Function = "Uncomment block               " + $Tab +  "Ctrl + W"
     Case %ID_REM      : BmpNum = 104 : Function = "Comment block               " + $Tab +  "Ctrl + Q"
     Case %ID_NOREM    : BmpNum = 105 : Function = "Uncomment block               " + $Tab +  "Ctrl + W"

     Case %ID_FIND_DIALOG    : BmpNum = 81 : Function = "Find..." + $Tab + "Ctrl+F"
     Case %ID_FIND_NEXT    : BmpNum = 0 : Function = "Find Next               " + $Tab + "  F3"
     Case %ID_REPLACE_DIALOG    : BmpNum = 82 : Function = "Replace... " + $Tab + " Ctrl+R
     Case %ID_GOTO_DIALOG    : BmpNum = 0 : Function ="Go to Line    " + $Tab + " Ctrl+G"
     Case %ID_CODE_FINDER_DIALOG    : BmpNum = 0 :Function = "Code Finder           " + $Tab + "   F2"
     Case %ID_BOOKMARKS    : BmpNum = 0 :Function ="   &Book Mark"
     Case %ID_BMSET    : BmpNum = 106 :Function ="Toggle on/of              "+ $Tab + " Ctrl+F2"
     Case %ID_BMSUBS    : BmpNum = 0 :Function ="All Subs/Functions"

     Case %ID_BMNEXT    : BmpNum = 0 :Function ="Goto Next" + Chr$(9) + "F2"

     Case %ID_BMPREV    : BmpNum = 0 :Function ="Goto Previous" + Chr$(9) + "Shift + F2"

     Case %ID_BMCLEAR    : BmpNum = 0 :Function ="Clear all"
     Case %ID_RUN    : BmpNum = 0 :Function ="Run"

     Case %ID_COMPILE : BmpNum = 88 :Function ="Compile "
     Case %ID_COMPILE_EXEC : BmpNum = 89 :Function ="Compile and Execute               "  + $Tab + " F5"

     Case %ID_TOOLS : BmpNum = 0 :Function ="Tools "
     Case %ID_OPTIONS  : BmpNum = 84 :Function ="Options               "

     Case %ID_HELP : BmpNum = 0 :Function ="Help"
     Case %ID_HELP_SDK : BmpNum = 86 :Function ="Help " & AppName & "               "  + $Tab + " F1"

     Case %ID_WEB : BmpNum = 10 :Function ="Web "
     Case %ID_ABOUT_DLG : BmpNum = 0 :Function ="About"


  End Select
End Function

'
' Draw ownerdrawn menu items - called from %WM_DRAWITEM
'--------------------------------------------------------------------
Sub DrawMenu (ByRef lp As Long)
  Local c                As Long        ' for/next counter
  Local ShortCutWidth    As Long        ' for ShortCut text width (if any)
  Local id               As Long        ' tmp item id
  Local BmpNum           As Long        ' bitmap number
  Local hBmp             As Long        ' icon to draw
  Local hBrush           As Long        ' brush used for selection draw
  Local bHighlight       As Long        ' higlighted flag
  Local drawTxtFlags     As Dword       ' how we draw the text
  Local drawBmpFlags     As Dword       ' how we draw the icon
  Local menuBtnW         As Long        ' Width of the menubutton, in pixels
  Local sCaption         As String      ' string for the menu item text
  Local sShortCut        As String      ' string for eventual shortcut text
  Local rc               As RECT        ' RECT used for drawing areas
  Local szl              As SIZEL       ' used to calculate text extent
  Local lpDis As DRAWITEMSTRUCT Ptr     ' we fill this from received pointer

  lpDis    = lp ' Get structure from given pointer
  menuBtnW = GetSystemMetrics(%SM_CYMENU) - 1 ' for "button" size

  '------------------------------------------------------------------
  ' Calculate pos for eventual shortcut. We need to look at all items
  ' in dropped menu and calculate largest width, which then is used
  ' as base to calculate all shortcuts' pos.
  '------------------------------------------------------------------
  For c = 0 To GetMenuItemCount(@lpDis.hwndItem) - 1 'hwndItem is dropped menu's handle
     id = GetMenuItemID(@lpDis.hwndItem, c)

     If id Then
        sCaption = GetMenuTxtAndBmp(id, 0)
        If InStr(sCaption, $Tab) Then       'if it has shortcut (Ctrl+X, etc.)
           sShortCut = Trim$(Parse$(sCaption, $Tab, 2))
        Else
           sShortCut = ""
        End If

        If Len(sShortCut) Then
           GetTextExtentPoint32 @lpDis.hDC, ByVal StrPtr(sShortCut), Len(sShortCut), ByVal VarPtr(szl)
           ShortCutWidth = Max&(ShortCutWidth, szl.cx)
        End If
     End If
  Next

  '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
  ' Get menu item string and split up into ev. text and shortcut part
  '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
  sCaption = GetMenuTxtAndBmp(@lpDis.itemID, BmpNum)
  If InStr(sCaption, $Tab) Then       'if it has shortcut (Ctrl+X, etc.)
     sShortCut = Trim$(Parse$(sCaption, $Tab, 2))
     sCaption  = Trim$(Parse$(sCaption, $Tab, 1))
  Else
     sCaption = Trim$(sCaption)
     sShortCut = ""
  End If

  '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
  ' Calculate menu item string's height
  '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
  GetTextExtentPoint32 @lpDis.hDC, ByVal StrPtr(sCaption), Len(sCaption), szl

  '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
  ' Sep up colors depending on what drawing actions we need to take
  '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
  If (@lpDis.itemState And %ODS_SELECTED) Then                     'menu item is selected
     hBrush =     GetSysColorBrush(%COLOR_HIGHLIGHT)
     SetBkColor   @lpDis.hDC, GetSysColor(%COLOR_HIGHLIGHT)
     SetTextColor @lpDis.hDC, GetSysColor(%COLOR_HIGHLIGHTTEXT)
     bHighlight   = %TRUE  'flag, so later we can add or remove the 3D edge around the icon
  ElseIf (@lpDis.itemState And %ODS_GRAYED) Then                   'menu item is disabled
     hBrush =     GetSysColorBrush(%COLOR_MENU)
     SetBkColor   @lpDis.hDC, GetSysColor(%COLOR_MENU)
     SetTextColor @lpDis.hDC, GetSysColor(%COLOR_MENUTEXT)
  Else                                                            'not selected or disabled
     hBrush =     GetSysColorBrush(%COLOR_MENU)
     SetBkColor   @lpDis.hDC, GetSysColor(%COLOR_MENU)
     SetTextColor @lpDis.hDC, GetSysColor(%COLOR_MENUTEXT)
  End If

  drawTxtFlags = %DST_PREFIXTEXT
  drawBmpFlags = %DST_BITMAP

  If (@lpDis.itemState And %ODS_GRAYED) Then      'if disabled item
     If (@lpDis.itemState And %ODS_SELECTED) Then 'if it's selected
        SetTextColor @lpDis.hDC, GetSysColor(%COLOR_GRAYTEXT)
     Else
        drawTxtFlags = drawTxtFlags Or %DSS_DISABLED
     End If
  End If

  '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
  ' Calculate rect for highlight area (selected item)
  ' and fill rect with proper color, either COLOR_MENU
  ' or COLOR_HIGHLIGHT, depending on selection state.
  '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
  rc = @lpDis.rcItem
  If (@lpDis.itemState And %ODS_GRAYED) Or BmpNum = 0 Then 'grayed or no bitmap
     rc.nLeft = 0
  Else
     rc.nLeft = menuBtnW + 4  'enabled, with bitmap
  End If
  FillRect @lpDis.hDC, rc, hBrush

  '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
  ' Draw the bitmap "button", if item is not grayed out (disabled)
  '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
  If (@lpDis.itemState And %ODS_GRAYED) = 0 Then
     If BmpNum > 0 Then hBmp = GetMenuBmpHandle(BmpNum - 1)

     If hBmp <> 0 Then     'Draw bitmap, centered in "button"
        DrawState @lpDis.hDC, 0&, 0&, hBmp, 0&, ((menuBtnW + 3) \ 2) - 8, _
                  ((@lpDis.rcItem.nTop + @lpDis.rcItem.nBottom) \ 2) - 8, _
                  16, 16, drawBmpFlags
        DeleteObject hBmp 'Delete the bitmap when done, to avoid memory leaks!

        '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        ' Calculate the RECT we need for the 3D edge
        '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        rc = @lpDis.rcItem
        rc.nLeft   = 0               'Size and pos for "button"..
        rc.nRight  = menuBtnW + 3
        rc.nBottom = rc.nTop  + GetSystemMetrics(%SM_CYMENU) + 1

        '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        ' Draw "button" if the item is highlighted, or flat if it's not
        '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        If bHighlight = %TRUE Then
           DrawEdge @lpDis.hDC, rc, %BDR_RAISEDINNER, %BF_RECT
        Else
           DrawEdge @lpDis.hDC, rc, %BDR_RAISEDINNER, %BF_FLAT Or %BF_RECT
        End If
     End If
  End If

  '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
  ' Draw the menu text next to bitmap button, with centered y-pos
  '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
  If Len(sCaption) Then
       rc.nLeft = menuBtnW + 6 : rc.nRight = @lpDis.rcItem.nRight
       rc.nTop = rc.nTop + ((rc.nBottom - rc.nTop) - szl.cy) \ 2
       DrawState @lpDis.hDC, 0&, 0&, ByVal StrPtr(sCaption), Len(sCaption), _
                 rc.nLeft, rc.nTop, rc.nRight, szl.cy, drawTxtFlags

     If ShortCutWidth Then 'if there's shortcut text (Ctrl+N, etc)
        DrawState @lpDis.hDC, 0&, 0&, ByVal StrPtr(sShortCut), Len(sShortCut), _
                  @lpDis.rcItem.nRight - ShortCutWidth - menuBtnW - 6, rc.nTop, _
                  rc.nRight, szl.cy, drawTxtFlags
     End If
  End If

End Sub

'
' GetMenuBmpHandle - get desired menu item's bitmap handle
'--------------------------------------------------------------------
Function GetMenuBmpHandle (ByVal BmpNum As Long) As Long
  Local hBmp1 As Dword, hBmp2 As Dword, _
        hDC As Dword, memDC1  As Dword, memDC2 As Dword

  hBmp1 = LoadImage(GetModuleHandle(""),  ByVal 4545, _  'Load Bmp strip from resource
                    %IMAGE_BITMAP, 0, 0, %LR_LOADMAP3DCOLORS Or %LR_DEFAULTSIZE  )


  hdc = GetDc(0)                     ' Get device context for screen
  memDC1 = CreateCompatibleDC (hDC)  ' Create two memory device contexts
  memDC2 = CreateCompatibleDC (hDC)
  hBmp2  = CreateCompatibleBitmap(hDC, 16, 16) ' Create compatible 16x16 pixel bmp
  ReleaseDC 0, hdc                   ' Release the DC - don't need it anymore.

  SelectObject memDC1, hBmp1         ' Select the bitmaps into the mem dc's
  SelectObject memDC2, hBmp2

  BitBlt memDC2, 0, 0, 16, 16, _     ' copy bNum part of hBmp1 strip to hBmp2
         memDC1, BmpNum * 16, 0, %SRCCOPY

  DeleteDC memDC1       'Cleanup memDC's and delete main bmp strip object
  DeleteDC memDC2
  DeleteObject hBmp1    '(note: 16x16 pixel hBmp2 is deleted in DrawMenu routine)

  Function = hBmp2      'return handle to 16x16 pixel bitmap
End Function

'
' MeasureMenu - %WM_MEASUREITEM handler
'--------------------------------------------------------------------
Sub MeasureMenu (ByVal hDlg As Dword, ByVal lParam As Dword)
 Local hDC As Dword, hf As Dword, txt As String, sl As SIZEL
 Local lpMis As MEASUREITEMSTRUCT Ptr, ncm As NONCLIENTMETRICS

  lpMis = lParam     'lParam points to a MEASUREITEMSTRUCT structure
  txt   = GetMenuTxtAndBmp(@lpMis.itemID, 0) 'get menu item's text

  hDC = GetDC(hDlg)          'grab dialog's DC
    ncm.cbSize = SizeOf(ncm) 'grab menu font
    SystemParametersInfo %SPI_GETNONCLIENTMETRICS, SizeOf(ncm), ByVal VarPtr(ncm), 0
    If Len(ncm.lfMenuFont) Then
       hf = CreateFontIndirect(ncm.lfMenuFont) 'create font from menu LogFont data
       If hf Then hf = SelectObject(hDC, hf)   'select it into DC
    End If
    GetTextExtentPoint32 hDC, ByVal StrPtr(txt), Len(txt), sl 'get text size
    @lpMis.itemWidth  = sl.cx                            'set width
    @lpMis.ItemHeight = GetSystemMetrics(%SM_CYMENU) + 1 'set height
    If hf Then DeleteObject SelectObject(hDC, hf)        'delete our tmp menu font object
  ReleaseDC hDlg, hDC  'release DC to avoid memory leak

End Sub
