
Function GetStringTable(ByVal id As Long) As String
'------------------------------------------------------------------------------
  ' Return a id related string table text
  '----------------------------------------------------------------------------
  Select Case As Long id
  Case %ID_NEW      : Function = "Create new file"
  Case %ID_OPEN     : Function = "Open file"
  Case %ID_SAVE     : Function = "Save file"
  Case %ID_SAVEAS   : Function = " Save file via dialog"
  Case %ID_PRINT    : Function = " Print active document"
  'Case %IDCANSEL     : Function = " Close PBNote2"
  Case %ID_UNDO     : Function = "Undo last action"
  Case %ID_REDO     : Function = "Redo last action"
  Case %ID_GOTO_DIALOG: Function = "Go to Line"
  Case %ID_CUT      : Function = " Cut to clipboard"
  Case %ID_COPY     : Function = " Copy to clipboard"
  Case %ID_PASTE    : Function = " Paste from clipboard"
  Case %ID_DELETE   : Function = " Delete selected text"
  Case %ID_SELALL   : Function = " Select all text"
  Case %ID_FIND_DIALOG: Function = "Find text"
  Case %ID_REPLACE_DIALOG:  Function = "Find text and replace"
  Case %ID_COMPILE: Function = "Compile the current file"
  Case %ID_COMPILE_EXEC: Function = "Compile and Execute current file"
  Case %ID_REM: Function = "Comment block"
  Case %ID_NOREM: Function = "Uncomment block"

  Case %ID_BMSET: Function ="Toogle BookMark on/off"
  Case %ID_BMNEXT: Function = "Goto Next"
  Case %ID_BMPREV: Function = "Goto Previous"
  Case %ID_HELP: Function = "Help"
  End Select
End Function





'
'    
'


Function SetLang() As Long

       Local ghSbIcon As Dword
       Local kb As Asciiz * 9
       Local lng As Long
       Local zText  As Asciiz * %MAX_PATH

       ghSbIcon = LoadImage(g_hInstance, "USA", %IMAGE_BITMAP    , 16, 16,  %LR_LOADTRANSPARENT Or %LR_DEFAULTSIZE)
       ' ghSbIcon = LoadImage(g_hInstance, "USA", %IMAGE_ICON   , 16, 16,   %LR_LOADTRANSPARENT Or %LR_DEFAULTSIZE )
      ' MSGBOX STR$(ghSbIcon)




        GetKeyboardLayoutName  kb
        lng=Val(kb)
        Select Case  lng
            Case 409
             zText="En"
             ghSbIcon = LoadImage(g_hInstance, "USA", %IMAGE_ICON   , 16, 16,    %LR_DEFAULTSIZE )
             SendMessage g_hStatus, %SB_SETTEXT, 5, VarPtr(zText)
             SendMessage g_hStatus, %SB_SETICON, 5,ghSbIcon
            Case 419
             zText="Ru"
             ghSbIcon = LoadImage(g_hInstance, "RUS", %IMAGE_ICON   , 16, 16,   %LR_DEFAULTSIZE )
             SendMessage g_hStatus, %SB_SETTEXT, 5, VarPtr(zText)
             SendMessage g_hStatus, %SB_SETICON, 5,ghSbIcon
           Case Else
               zText="ID:" & Str$(lng)
               ghSbIcon = LoadImage(g_hInstance, "NO", %IMAGE_ICON   , 16, 16,    %LR_DEFAULTSIZE )
               SendMessage g_hStatus, %SB_SETTEXT, 5, VarPtr(zText)
               SendMessage g_hStatus, %SB_SETICON, 5,ghSbIcon


         End Select
        '*******************************************************
End Function








'
'      
'






'
'    
'
Function LoadIconOrCursorFromRes( ByVal hInstance As Long, ByVal RCDATAName As String ) As Long

    Dim hRes        As Long
    Dim ResLen      As Long
    Dim hMem        As Long
    Dim lMem        As Long
    Dim nID         As Long
    Dim IsIcon      As Long

    '// Specify 0 to use the current app/dll.
    If hInstance = 0 Then hInstance = GetModuleHandle( ByVal 0& )

    '// Load the icon/cursor by using the directory (%RT_GROUP_...)
    '// Try icon first

     hRes = FindResource( hInstance, ByVal StrPtr( RCDATAName ), ByVal %RT_GROUP_ICON )



    If hRes Then

        IsIcon = -1

    Else

        '// Is it a cursor?
       hRes = FindResource( hInstance, ByVal StrPtr( RCDATAName ), ByVal %RT_GROUP_CURSOR )

       If hRes = 0 Then Exit Function

    End If

    '// We found the group, retrieve the necessary icon/cursor id to load later.
    hMem = LoadResource( hInstance, hRes )
    lMem = LockResource( hMem )
    nID  = LookupIconIdFromDirectoryEx( ByVal lMem, IsIcon, 0, 0, %LR_DEFAULTCOLOR )
    FreeResource hRes
    hRes = 0

    '// Search the icon/cursor using the id.
    hMem = %RT_CURSOR

    If IsIcon Then hMem = %RT_ICON

    hRes   = FindResource( hInstance, "#" & Trim$( Str$( nID ) ), ByVal hMem )

    '// Should not happen.
    If hRes = 0 Then Exit Function

    '// Load the icon/cursor resource
    hMem   = 0
    ResLen = SizeOfResource( hInstance, hRes )
    hMem   = LoadResource( hInstance, hRes )
    lMem   = LockResource( hMem )

    '// Create the icon/cursor.
    Function = CreateIconFromResource( ByVal lMem, ResLen, IsIcon, &H30000& )

    FreeResource hRes

End Function
