'--------------------------------------------------------------------
%ID_NEW      = 110       'Control Id's
%ID_OPEN     = 111
%ID_SAVE     = 112
%ID_SAVEAS   = 114
%ID_PRINT    = 115
%ID_LBL1     = 130
%ID_LBL2     = 131
%ID_LBL3     = 132
%ID_LBL4     = 133
%ID_COMBO    = 140
%ID_EDIT     = 150
%ID_UNDO     = 160
%ID_REDO     = 161
%ID_CUT      = 162
%ID_COPY     = 163
%ID_PASTE    = 164
%ID_DELETE   = 165
%ID_SELALL   = 166
%ID_LINES    = 167
%ID_UCASE    = 170
%ID_LCASE    = 171
%ID_MCASE    = 172
%ID_TCASE    = 173
%ID_REM      = 180
%ID_NOREM    = 181
%ID_INDENT   = 182
%ID_OUTDENT  = 183
%ID_SORTASC  = 184
%ID_SORTDESC = 186
%ID_BMSET    = 190
%ID_BMSUBS   = 191
%ID_BMNEXT   = 193
%ID_BMPREV   = 194
%ID_BMCLEAR  = 195
%ID_SYNTAX   = 200
%ID_GRID     = 201
%ID_SNPRINT  = 202
%ID_DOCINFO  = 210
%IDM_Delim1  = 5051
%ID_FIND_DIALOG = 300
%ID_FIND_NEXT = 301
%ID_REPLACE_DIALOG = 302
%ID_GOTO_DIALOG = 303
%ID_CODE_FINDER_DIALOG = 304

%ID_ABOUT    = 310
%ID_OPTIONS_EDITOR = 400
%ID_BOOKMARKS = 401

%ID_RUN = 500
%ID_COMPILE = 501
%ID_COMPILE_EXEC = 502

%ID_TOOLS=600
%ID_OPTIONS=601

%ID_HELP=700
%ID_HELP_SDK=703
%ID_WEB=701
%ID_ABOUT_DLG=702






'--------------------------------------------------------------------
%ID_STATUSBAR         = %WM_USER      + 1025&  ' statusbar
%ID_TOOLBAR           = %WM_USER      + 1024&  ' toolbar

'--------------------------------------------------------------------
'%IDM_FILE_CUT = 5060

'---Main Window Identifiers
%IDC_FINDDLG = 102 ' Find button
%IDC_CANCEL = 103 ' Exit button
%IDC_REPLACEDLG = 104 ' Replace button
%IDC_EDIT = 200 ' one instance of EDM32.INC control
%IDC_FINDNEXT = 105 ' Find Next button
%IDC_GOTOLINE = 106 ' Go to line button

'---MYFIND dialog ID's --------------------------------------------------------
%IDC_FIND_LABEL1 = 4000 ' Label "Find What:"
%IDC_FIND_COMBOBOX1 = 4001 ' Combobox
%IDC_FIND_CHECK1 = 4002 ' AutoCheckbox "Match Whole Words"
%IDC_FIND_CHECK2 = 4003 ' AutoCheckbox "Match Case"
%IDC_FIND_GROUPBOX1 = 4004 ' Groupbox "Direction"
%IDC_FIND_RADIO1 = 4005 ' AutoRadiobutton "Up"
%IDC_FIND_RADIO2 = 4006 ' AutoRadiobutton "down"
%IDC_FIND_BUTTON1 = 4007 ' default pushbutton "Find Next"
%IDC_FIND_BUTTON2 = 4008 ' pushbutton "Close"

'MYREPLACE dialog ID's
%IDC_REPLACE_LABEL1 = 4100 ' Label "Find What:"
%IDC_REPLACE_COMBOBOX1 = 4101 ' Combobox 1
%IDC_REPLACE_LABEL2 = 4102 ' Label "Replace With:"
%IDC_REPLACE_COMBOBOX2 = 4103 ' Combobox 2
%IDC_REPLACE_CHECK1 = 4104 ' AutoCheckbox "Match Whole Words"
%IDC_REPLACE_CHECK2 = 4105 ' AutoCheckbox "Match Case"
%IDC_REPLACE_BUTTON1 = 4106 ' default pushbutton "Find Next"
%IDC_REPLACE_BUTTON2 = 4107 ' pushbutton "Replace"
%IDC_REPLACE_BUTTON3 = 4108 ' pushbutton "Replace All"
%IDC_REPLACE_BUTTON4 = 4109 ' pushbutton "Close"

'MYGOTOLINE dialog ID's
%IDC_GOTO_GROUPBOX1 = 4200 ' Groupbox
%IDC_GOTO_LABEL1 = 4201 ' Label "Last Line"
%IDC_GOTO_LABEL2 = 4202 ' Label #
%IDC_GOTO_LABEL3 = 4203 ' Label "Current Line"
%IDC_GOTO_LABEL4 = 4204 ' Label #
%IDC_GOTO_LABEL5 = 4205 ' Label "Go To Line
%IDC_GOTO_EDITBOX1 = 4206 ' Editbox, numbers only
%IDC_GOTO_BUTTON1 = 4207 ' default button "OK"
%IDC_GOTO_BUTTON2 = 4208 ' button "Cancel"





%IDM_RECENT1          = %WM_USER      + 2010&  ' Recently opened file 1
%IDM_RECENT2          = %WM_USER      + 2011&  ' Recently opened file 2
%IDM_RECENT3          = %WM_USER      + 2012&  ' Recently opened file 3
%IDM_RECENT4          = %WM_USER      + 2013&  ' Recently opened file 4
%IDM_RECENT5          = %WM_USER      + 2014&  ' Recently opened file 5
%IDM_RECENT6          = %WM_USER      + 2015&  ' Recently opened file 6
%IDM_RECENT7          = %WM_USER      + 2016&  ' Recently opened file 7
%IDM_RECENT8          = %WM_USER      + 2017&  ' Recently opened file 8


$INIFILENAME      = "editor.ini"    ' configuration file

Global ghFindDlg As Long ' prevent multiple Find dialogs
Global ghReplaceDlg As Long ' prevent multiple Replace dialogs

Global gFindNextTxt As String ' save last find text
Global gFindTxt() As String ' array of recent "find text" for combobox, Find dlg
Global gFindRepTxt() As String ' array of recent "Find text" for combobox, Replace dlg
Global gRepWithTxt() As String ' array of recent "Replace with" for combobox, Replace dlg
Global gbFindDir As Long ' Find search direction up/down
Global gbFindMcase As Long ' Find dlg mCase option
Global gbFindWhole As Long ' Find dlg whole option
Global gbRepMcase As Long ' Replace dlg mCase option
Global gbRepWhole As Long ' Replace dlg whole option
'-------------------------------------------------



Global g_MainDialog As Dword
Global ghCombo As Dword, ghEdit As Dword, ghMenuPopup As Dword, ghMenuPop4 As Dword

Global g_NewComCtl    As CurrencyX
Global g_hStatus      As Dword
Global g_hToolbar     As Dword
Global g_hInstance    As Dword

Global AppName As String

Global g_hMenuReopen  As Dword
Global g_hMenuFile    As Dword
Global g_zIni         As Asciiz * %MAX_PATH
Global g_FreezeMenu   As Long




'--------------------------------------------------------------------
Declare CallBack Function DlgMainProc
Declare Function CheckSaveStatus(ByVal hDlg As Dword) As Long
Declare Sub OpenEdmFile(ByVal hDlg As Dword)
Declare Sub SaveEdmFile(ByVal hDlg As Dword)
Declare Sub ShowMenuEdit
Declare Function ShowFindDialog() As Long

Declare Function LoadIconOrCursorFromRes( ByVal hInstance As Long, ByVal RCDATAName As String ) As Long



Declare Function AttachACCELERATOR1(ByVal hDlg As Dword) As Dword
Declare Function AssignAccel(tAccel As ACCELAPI, ByVal wKey As Word, ByVal wCmd As Word, ByVal byFVirt As Byte) As Long


Declare Sub addMenu     (ByVal hDlg As Dword)
Declare Sub DrawMenu    (ByRef lp As Long)
Declare Sub MeasureMenu (ByVal hDlg As Dword, ByVal lParam As Dword)

Declare Function GetMenuTxtAndBmp (ByVal ItemId As Long, BmpNum As Long) As String
Declare Function GetMenuBmpHandle (ByVal bNum As Long) As Long


%ID_TEXT = 20
Global iMsgFindReplace As Long
Global OldTextProc     As Long

Declare CallBack Function DlgProc() As Long
Declare Function PopFindFindDlg (ByVal hWnd As Long, ByVal sFindText As String) As Long

Global ghImgList As Dword
Declare Sub AddTextAndPicture (ByVal hDlg As Dword, txt As String, ByVal bmpFile As String)


Declare Function  SetLang() As Long
Declare Function GetStringTable(ByVal id As Long) As String

Declare Function SearchFindDlgProc(ByVal hDlg As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Declare Sub UpdateComboList(ByVal MainhWnd As Long, ByVal comboID As Long, ByVal strTxt As String)
Declare Function MsgBoxApi (ByVal hParent As Long, ByVal sMsg As String, ByVal sTitle As String, ByVal dwFlags As Dword) As Long

Declare Sub WriteRecentFiles (ByVal OpenFName As String)
